#!/usr/bin/perl -I/usr/sausalito/perl

use strict;
use CCE;

my $cce = new CCE(Domain => "base-winnetwork");
$cce->connectfd();

my $old = $cce->event_old();
my $new = $cce->event_object();

my $destroy = $cce->{destroyflag};

my $ok = 0;

# Check that this machine name isn't already taken...
my @oids = $cce->find("WindowsMachine", {name=>$new->{name}});

if (@oids > 1 || 
	(@oids == 1 && $oids[0] != $cce->event_oid())) {
	$cce->warn("windowsMachineAlreadyExists", {name=>$new->{name}});
	$cce->bye("FAIL");
	exit;
}


# clear the old name if it exists..
if ($old->{name}) {
	$old->{name} =~ s/[`';]/_/g;
	if ((system ("/usr/bin/smbpasswd -x '". $old->{name} . "\$' > /dev/null")  
           || system ("/usr/sbin/userdel '" . $old->{name} . "\$' > /dev/null")) 
&& (!$destroy)) {
		$cce->warn("couldNotClearOldMachine", {name=>$old->{name}});
		$cce->bye("FAIL");
		exit;
	}
}

if (!$destroy) {
        $new->{name} =~ s/[`';]/_/g;
	if (system ("/usr/sbin/useradd -d /dev/null -s /bin/false '" . $new->{name} . "\$' > /dev/null")
	   || system ("/usr/bin/smbpasswd -a -m '" . $new->{name} . "' > /dev/null")
) {
		$cce->warn("couldNotCreateNewMachine", {name=>$new->{name}}); 
		$cce->bye("FAIL");
		exit;
	}
}

$cce->bye("SUCCESS");
